
#include "tools.h"

/*
///////////////////////////////////////////////////////////////////////////////
//
//  Generic system-wide random number generator (not thread-safe)
//

Random random;
*/
///////////////////////////////////////////////////////////////////////////////
//
//  Conversion between strings and numbers
//

std::string Int2String( int value )
{
    char s[32];
    sprintf( s, "%i", value );
    return s;
}

/*
string Unsigned2String( unsigned value )
{
    char s[32];
    sprintf( s, "%u", value );
    return s;
}

string Float2String( double value, size_t precision )
{
    char s[64];
    string fmt = "%." + Int2String( int(precision) ) + "G";
    sprintf( s, fmt.c_str(), value );
    return s;
}

int String2Int( const string& s )
{
    int value = 0;
    sscanf( s.c_str(), "%d", &value );
    return value;
}

unsigned String2Unsigned( const string& s )
{
    unsigned value = 0;
    sscanf( s.c_str(), "%u", &value );
    return value;
}

double String2Float( const string& s )
{
    float value;
    sscanf( s.c_str(), "%f", &value );
    return double(value);
}

///////////////////////////////////////////////////////////////////////////////
//
//  Binary strings
//

void Bin2String( const vector<char>& input, string* p_output )
{
    // Check input and output
    assert( p_output );
    if ( input.empty() ) {
        p_output->clear();
        return;
    }

    // Calculate real lengths and allocate output memory
    const size_t bin_bytes = input.size();
    const size_t str_lines = (bin_bytes * 2 - 1) / 78 + 1;
    const size_t str_bytes = bin_bytes * 2 + 2 * (str_lines-1);
    p_output->resize( str_bytes );

    // Conversion table
    static const char hexdigits[] = "0123456789ABCDEF";

    // Encode subsequent bytes
    size_t num_in_line = 0;
    char* out = &(*p_output)[0];
    FOR_INDEX( i, bin_bytes ) {

        // New line if number of characters exceedes current line
        num_in_line += 2;
        if ( num_in_line >= 80 )
            *(out++) = '\r',
            *(out++) = '\n',
            num_in_line = 2;

        // Convert byte
        const char c = input[i];
        const int hi = int(unsigned8(c)) >> 4;
        const int lo = int(unsigned8(c)) & 15;
        *(out++) = hexdigits[hi];
        *(out++) = hexdigits[lo];
    }
    assert( out-&(*p_output)[0] == str_bytes );
}

void String2Bin( const string& input, vector<char>* p_output )
{
    // Prepare output
    assert( p_output );
    p_output->clear();
    if ( input.empty() )
        return;
    const size_t est_lines = (input.size()-1) / 80 + 1;
    const size_t est_bytes = (est_lines-1) * (78/2) + (input.size() - (est_lines-1)*80) / 2;
    p_output->reserve( est_bytes );

    // Decode subsequent bytes
    const char* in = &input[0];
    const char* in_end = in + input.size();
    do {
        // Get MS part
        char hi = '\0';
        do hi = *(in++);
        while ( in < in_end && !((hi>='0'&&hi<='9') || (hi>='a'&&hi<='f') || (hi>='A'&&hi<='F')) );
        if ( in >= in_end )
            break;
        hi -= '0';
        if ( hi > 9 ) {
            if ( hi >= 'a'-'0' )
                hi -= 'a'-'9'-1;
            else
                hi -= 'A'-'9'-1;
        }

        // Get LS part
        char lo = '\0';
        do lo = *(in++);
        while ( in < in_end && !((lo>='0'&&lo<='9') || (lo>='a'&&lo<='f') || (lo>='A'&&lo<='F')) );
        lo -= '0';
        if ( lo > 9 ) {
            if ( lo >= 'a'-'0' )
                lo -= 'a'-'9'-1;
            else
                lo -= 'A'-'9'-1;
        }

        // Assemble and output byte
        p_output->push_back( char( (unsigned8(hi)<<4) | (unsigned8(lo)&15) ) );
    } while ( in < in_end );
}

///////////////////////////////////////////////////////////////////////////////
//
//  Check if the specified byte stream represents a supported image type
//

bool ImageDecoder::IsImage( const vector<char>& input )
{
    RegPtr<ImageDecoder> p_reg;
    FOR_CONST_ITER( decoder_it, *p_reg, RegPtr<ImageDecoder> ) {
        ImageDecoder* p_decoder = decoder_it->second;
        if ( p_decoder->CanDecode( input ) )
            return true;
    }
    return false;
}

///////////////////////////////////////////////////////////////////////////////
//
//  Find a matching decoder and decode image
//

void ImageDecoder::Decode( const vector<char>& input, vector<char>* p_output, int* p_width, int* p_height )
{
    RegPtr<ImageDecoder> p_reg;
    FOR_CONST_ITER( decoder_it, *p_reg, RegPtr<ImageDecoder> ) {
        ImageDecoder* p_decoder = decoder_it->second;
        if ( p_decoder->CanDecode( input ) ) {
            p_decoder->DecodeImage( input, p_output, p_width, p_height );
            return;
        }
    }
    throw "Unsupported image type";
}
*/

// vim:ts=4:sts=4:et
