
#define PNG_INTERNAL
#include "png.h"

void png_throw_error()
{
	throw "PNG decompression error";
}

/* This function is called when the application wants to use another method
* of handling errors and warnings.  Note that the error function MUST NOT
* return to the calling routine or serious problems will occur.  The return
* method used in the default routine calls longjmp(png_ptr->jmpbuf, 1)
*/
void PNGAPI
png_set_error_fn(png_structp png_ptr, png_voidp error_ptr,
				 png_error_ptr error_fn, png_error_ptr warning_fn)
{
	png_ptr->error_ptr = error_ptr;
	png_ptr->error_fn = error_fn;
	png_ptr->warning_fn = warning_fn;
}
