
#ifndef __MAIN_WINDOW_H_INCLUDED
#define __MAIN_WINDOW_H_INCLUDED

#define WIN32_LEAN_AND_MEAN     // Exclude rarely-used stuff from Windows headers
#include <winapi.h>
#include <d3d9.h>
#include <d3dx9.h>

class MainWindow: public WinAPI::Window {
public:
    MainWindow();

protected:
    virtual void OnDestroy();
    virtual bool OnCreate( LPCREATESTRUCT lpCreateStruct = 0 );
    virtual int HandleMessage( int uMsg, int wParam, int lParam );
    virtual void OnSize( int sizing, WinAPI::WSize new_size );
    virtual void OnCommand( int nIdentifier, int nNotifyCode, HWND hwndControl );

private:
    void SetFiltering( DWORD stage ) const;
    void DrawFrame();
    void SetTSS( const std::vector<DWORD>& states ) const;
    void DefaultTSS() const;

    int x_dlu , y_dlu;
    int btn_width, btn_height;
    int window_width, window_height;
    WinAPI::Static stc_image;
    WinAPI::Edit ed_shader;
    WinAPI::Edit ed_code;
    WinAPI::Button btn_compile;
    WinAPI::CheckBox chk_alphablend;
    WinAPI::IPtr<IDirect3D9> p_d3d;
    WinAPI::IPtr<IDirect3DDevice9> p_device;
    WinAPI::IPtr<IDirect3DTexture9> p_background;
    std::vector< WinAPI::IPtr<IDirect3DTexture9> > p_texture;
    std::vector<DWORD> stage_states;
    D3DCAPS9 caps;
    LARGE_INTEGER base_time;
};

#endif // __MAIN_WINDOW_H_INCLUDED

// vim:ts=4:sts=4:et
