
#define WIN32_LEAN_AND_MEAN     // Exclude rarely-used stuff from Windows headers
#include <winapi.h>
#include <d3d9.h>
#include <d3dx9.h>

std::string AssembleShader( const std::string& source_code, std::vector<unsigned int>* p_executable )
{
    assert( p_executable );

    WinAPI::IPtr<ID3DXBuffer> p_shader, p_errors;
    if ( FAILED( D3DXAssembleShader( source_code.data(), int(source_code.length()), 0, 0, D3DXSHADER_DEBUG, p_shader.GetPP(), p_errors.GetPP() ) ) ) {
        const std::string errors( (const char*)p_errors->GetBufferPointer() );
        return errors;
    }

    p_executable->resize( p_shader->GetBufferSize()/4 );
    const char* src = (const char*)p_shader->GetBufferPointer();
    for ( size_t i=0; i < p_executable->size(); i++, src += 4 )
        (*p_executable)[i] = *reinterpret_cast<const unsigned int*>( src );
    return "";
}

// vim:ts=4:sts=4:et
