
#ifndef __MAIN_WINDOW_H_INCLUDED
#define __MAIN_WINDOW_H_INCLUDED

#include "gl_pixel_shader.h"
#include "glext.h"

class MainWindow: public WinAPI::Window {
public:
	MainWindow();

protected:
	virtual void OnDestroy();
	virtual void OnClose();
	virtual bool OnCreate( LPCREATESTRUCT lpCreateStruct = 0 );
	virtual int HandleMessage( int uMsg, int wParam, int lParam );
	virtual void OnSize( int sizing, WinAPI::WSize new_size );
	virtual void OnCommand( int nIdentifier, int nNotifyCode, HWND hwndControl );

private:
	void DrawFrame();
	static GLint LoadTexture( const std::string& filename );
	bool SetTexEnv( const std::vector<TEXENVVALUE> setup );
	void DefaultTexEnv();

	int x_dlu , y_dlu;
	int btn_width, btn_height;
	int window_width, window_height;
	WinAPI::Static stc_image;
	WinAPI::Edit ed_shader;
	WinAPI::Edit ed_code;
	WinAPI::Button btn_compile;
	WinAPI::CheckBox chk_alphablend;

	HGLRC hrc;
	HDC hdc;
	GLuint background;
	std::vector< GLuint > texture;

	std::vector<TEXENVVALUE> texenv_setup;
	GLint max_texture_units;
	PFNGLACTIVETEXTUREARBPROC glActiveTexture;
	PFNGLCLIENTACTIVETEXTUREARBPROC glClientActiveTexture;
	PFNGLMULTITEXCOORD2FARBPROC glMultiTexCoord2f;

	LARGE_INTEGER base_time;
};

#endif // __MAIN_WINDOW_H_INCLUDED

// vim:ts=4:sts=4:et
